////////////////////////////////////////////////////////////////////
// Uq^V~[V
////////////////////////////////////////////////////////////////////
#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <direct.h>
#include <stdlib.h>
#include <omp.h>

#include "Vector3.h"
#include "RK4.h"


////////////////////////////////////////////////////////////////////
// p[^
////////////////////////////////////////////////////////////////////
//
double T = 100.0;
//̍
const int N = 100;

//͈̔
double t_min = 0;
double t_max = 30;
double dt = 0.001;
//d͉x
double g = 10.0;
//
double m = 1.0;
//Ђ̒
double L = 1.0;
//x_̍
double z_box = L;

//ŮpU
double omega_box = sqrt(g / L);//[rad/s]
//U̐U
double l = 0.2;

int NN = round((t_max - t_min) / dt);
int skip = 50;
double max_x_box = 0;

//wK
int iteration = 0;
double eta = 0.01;
double dB = 0.01;

//f[^[hꍇ̓RgO
//#define LOADING

//␳p[^
double compensationK = 0;//0.3; //␳΂˒eW
double compensationGamma = 0;//0.02; //␳SRW

////////////////////////////////////////////////////////////////////
// qNX
////////////////////////////////////////////////////////////////////
class Particle : public RK4 {
private:
public:
	//Uq̊pU
	double Bn[N + 1] = { 0.0 };

	//RXgN^
	Particle() {}
	Particle(double _dt) {
		dt = _dt;
	}
	Particle(double _dt, Vector3& _r, Vector3& _v) {
		dt = _dt;
		r.copy(_r);
		v.copy(_v);
	}
	//x_̈ʒuxNgExxNgExxNg
	Vector3 r_box_function(double t) {
		Vector3 r_box(0, 0, z_box);

		for (int n = 1; n <= N; n++) {
			r_box.x += l * Bn[n] * sin(2.0 * M_PI * n / T * t);
		}
		return r_box;
	};
	Vector3 v_box_function(double t) {
		Vector3 v_box(0, 0, 0);
		for (int n = 1; n <= N; n++) {
			v_box.x += l * Bn[n] * 2.0 * M_PI * n / T * cos(2.0 * M_PI * n / T * t);
		}
		return v_box;
	};
	Vector3 a_box_function(double t) {
		Vector3 a_box(0, 0, 0);
		for (int n = 1; n <= N; n++) {
			a_box.x += -l * Bn[n] * pow(2.0 * M_PI * n / T, 2) * sin(2.0 * M_PI * n / T * t);
		}
		return a_box;
	};
	//͂̑傫
	double S(double t, Vector3 r, Vector3  v) {
		Vector3 r_box = r_box_function(t);
		Vector3 v_box = v_box_function(t);
		Vector3 a_box = a_box_function(t);
		Vector3 vecL = r - r_box;
		Vector3 vecV = v - v_box;
		return -m * (vecV.lengthSq() - a_box.dot(vecL) - g * vecL.z) / (vecL.lengthSq());
	};
	//xxNgiK{j
	Vector3 A(double t, Vector3& r, Vector3& v) {
		Vector3 r_box = r_box_function(t);
		Vector3 v_box = v_box_function(t);
		Vector3 a_box = a_box_function(t);

		Vector3 a;
		a.x = S(t, r, v) / m * (r.x - r_box.x);
		a.y = S(t, r, v) / m * (r.y - r_box.y);
		a.z = -g + S(t, r, v) / m * (r.z - r_box.z);

		//␳
		Vector3 _L = r - r_box;
		//std::cout << L - _L.length() << std::endl;

		Vector3 hatL = _L.clone().normalize();
		//␳΂˒e
		Vector3 fk = hatL.clone() * (-compensationK * (L - _L.length()));
		//x␳
		Vector3 barV = v - v_box;
		//␳SR
		Vector3 fgamma = hatL.clone() * (-compensationGamma * barV.dot(hatL));

		a += fk / m + fgamma / m;

		return a;
	};
};

double maxEnergy(double* Bn, bool flag_dL = false) {

	//QNb^IuWFNg̐
	Particle particle(dt);
	//ʒuxNgƑxxNg
	particle.r.set(0, 0, 0);
	particle.v.set(0, 0, 0);

	for (int i = 0; i <= N; i++) {
		particle.Bn[i] = Bn[i];
	}

	double maxE = 0;
	int NN = round((t_max - t_min) / dt);
	for (int i = 0; i <= NN; i++) {
		double t = i * dt;

		double E = 1.0 / 2.0 * m * particle.v.lengthSq() + m * g * particle.r.z;
		if (maxE < E) maxE = E;

		//QENb^@ɂ鎞ԔW
		particle.timeEvolution(t);

		//ʒu̍XV
		particle.r = particle.r + particle.dr;
		//x̍XV
		particle.v = particle.v + particle.dv;

		Vector3 r_box_last = particle.r_box_function(t);
		double _L = Vector3::distance(r_box_last, particle.r);

		//if (i % 100 == 0)std::cout << " E= " << E << "  " << "L=" << _L - L << std::endl;
		if (abs(_L - L) > 0.01) std::cout << "L=" << _L - L << std::endl;
	}
	return maxE;
}
void locus(double* Bn, Vector3* out_r, Vector3* out_v, Vector3* out_rb, Vector3* out_vb, Vector3* out_ab ) {

	//QNb^IuWFNg̐
	Particle particle(dt);
	//ʒuxNgƑxxNg
	particle.r.set(0, 0, 0);
	particle.v.set(0, 0, 0);

	for (int i = 0; i <= N; i++) {
		particle.Bn[i] = Bn[i];
	}

	for (int i = 0; i <= NN; i++) {
		double t = i * dt;

		if (i%skip == 0) {
			out_r[i / skip].copy(particle.r);
			out_v[i / skip].copy(particle.v);


			for (int n = 1; n <= N; n++) {
				out_rb[i / skip].x += l * Bn[n] * sin(2.0 * M_PI * n / T * t);
			}
			for (int n = 1; n <= N; n++) {
				out_vb[i / skip].x += l * Bn[n] * 2.0 * M_PI * n / T * cos(2.0 * M_PI * n / T * t);
			}
			for (int n = 1; n <= N; n++) {
				out_ab[i / skip].x += -l * Bn[n] * pow(2.0 * M_PI * n / T, 2) * sin(2.0 * M_PI * n / T * t);
			}


		}

		//QENb^@ɂ鎞ԔW
		particle.timeEvolution(t);

		//ʒu̍XV
		particle.r = particle.r + particle.dr;
		//x̍XV
		particle.v = particle.v + particle.dv;

	}
}

double checkDx(double* Bn) {

	double maxDx = 0;

	for (int i = 0; i <= NN; i++) {
		double t = t_min + (t_max - t_min) / NN * i;
		double x = 0;
		for (int n = 1; n <= N; n++) {
			x += l * Bn[n] * sin(2.0 * M_PI * n / T * t);
		}
		if (maxDx < abs(x)) {
			maxDx = abs(x);
		}
	}

	return maxDx;
}


////////////////////////////////////////////////////////////////////
// C֐
////////////////////////////////////////////////////////////////////
int main(void) {
	//tH_̐
	_mkdir("output");

	//WJW
	double Bn[N + 1] = { 0.0 };
	double dBn[N + 1] = { 0.0 };
	double dEn[N + 1] = { 0.0 };

	//ł悢WJWi[
	double maxE = 0;
	double Bn_best[N + 1] = { 0.0 };


	//t@C̐ݒ
	std::ostringstream filename;
	std::ifstream if_coefficient;

#ifdef LOADING
	//t@C̐ݒ
	filename << "input/ForcedVibrationSinglePendulumMotion_coefficient.txt";
	//o̓Xg[ɂt@CI[v
	if_coefficient.open(filename.str());
	std::string str;
	while (getline(if_coefficient, str)) {
		if (str.find("#") != std::string::npos) continue;
		std::istringstream iss(str);
		std::string s1, s2;
		iss >> s1;
		iss >> s2;
		std::cout << atoi(s1.c_str()) << " " << atof(s2.c_str()) << std::endl;

		Bn[atoi(s1.c_str())] = atof(s2.c_str());
		Bn_best[atoi(s1.c_str())] = atof(s2.c_str());
	}
#else

	////l
	for (int n = 0; n <= N; n++) {
		//Bn[n] = 1.0 / (N + 1);
	}

	//Bn[50] = 1.0;
	Bn_best[50] = 1.0;


	//W̘avZ
	double sumBn = 0;
	for (int n = 0; n <= N; n++) {
		sumBn += abs(Bn[n]);
	}
	//Ki
	for (int n = 0; n <= N; n++) {
		Bn[n] /= sumBn;
	}

#endif


	//t@C̐ݒ
	std::ostringstream filename_log;
	filename_log << "output/log.txt";
	// t@Co̓Xg[̏
	std::ofstream ofs_log(filename_log.str());


	//t@C̐ݒ
	std::ostringstream filename1;
	filename1 << "output/ForcedVibrationSinglePendulumMotion_Energy_" << l << ".txt";
	// t@Co̓Xg[̏
	std::ofstream ofs(filename1.str());

	ofs << "#x:wK" << std::endl;
	ofs << "#y:őGlM[" << std::endl;
	//ofs << "#legend: ő" << std::endl;
	ofs << "#showLines: true true true true true true" << std::endl;
	ofs << "#showMarkers: false false false false false false" << std::endl;
	ofs << "#fills: false false false false false false" << std::endl;
	ofs << "#xrange:" << 0 << " " << iteration << " " << iteration / 10 << std::endl;
	ofs << "#yrange:" << 0 << " " << 20.0 << " " << 2 << std::endl;



	//ƂȂGlM[
	double E = maxEnergy(Bn);
	maxE = E;
	std::cout << 0 << " E=" << E << std::endl;
	ofs << 0 << " " << E << std::endl;

	for (int i = 1; i <= iteration; i++) {

		for (int n = 0; n <= N; n++) {
			dBn[n] = 0;
			dEn[n] = 0;
		}

#pragma omp parallel for
		for (int n = 0; n <= N; n++) {

			double _Bn[N + 1] = { 0.0 };

			//Rs[
			for (int _n = 0; _n <= N; _n++) {
				_Bn[_n] = Bn[_n];
			}

			//ɂ炷
			_Bn[n] += dB;
			{
				//W̘avZ
				double sumBn = 0;
				for (int _n = 0; _n <= N; _n++) {
					sumBn += abs(_Bn[_n]);
				}
				//Ki
				for (int _n = 0; _n <= N; _n++) {
					_Bn[_n] /= sumBn;
				}
				//GlM[̑`FbN
				double dE = maxEnergy(_Bn) - E;

				if (dE > 0) {
					//ύXʂi[
					dBn[n] += eta * dE / dB;
					std::cout << "n+:" << n << " dE:" << dE << std::endl;
					dEn[n] = dE;
				}
			}

			//Rs[
			for (int _n = 0; _n <= N; _n++) {
				_Bn[_n] = Bn[_n];
			}

			//ɂ炷
			_Bn[n] -= dB;

			{
				//W̘avZ
				double sumBn = 0;
				for (int _n = 0; _n <= N; _n++) {
					sumBn += abs(_Bn[_n]);
				}
				//Ki
				for (int _n = 0; _n <= N; _n++) {
					_Bn[_n] /= sumBn;
				}
				//GlM[̑`FbN
				double dE = maxEnergy(_Bn) - E;

				if (dE > 0) {
					//ύXʂi[
					dBn[n] += -eta * dE / dB;
					std::cout << "n-:" << n << " dE:" << dE << std::endl;
					dEn[n] = dE;
				}
			}

		}

		double maxdE = 0;
		double sumdE = 0;
		int update_n = 1000;
		for (int n = 0; n <= N; n++) {

			if (maxdE < dEn[n]) {
				maxdE = dEn[n];
				update_n = n;
			}
			sumdE += dEn[n];
		}


		//W̍XV
		if (i % 3 == 1) {
			if (update_n != 1000) {

				Bn[update_n] += dBn[update_n];
				std::cout << "update n:" << update_n << std::endl;
			}
			else {
				std::cout << "no update" << std::endl;
				break;
			}
		}
		else {

			for (int n = 0; n <= N; n++) {
				Bn[n] += dBn[n] * dEn[n] / sumdE;
			}
		}

		//W̘avZ
		double sumBn = 0;
		for (int n = 0; n <= N; n++) {
			sumBn += abs(Bn[n]);
		}
		//Ki
		for (int n = 0; n <= N; n++) {
			Bn[n] /= sumBn;
		}

		E = maxEnergy(Bn);
		std::cout << "--------------------" << std::endl;
		std::cout << "ite:" << i << "   E=" << E << std::endl;
		std::cout << "--------------------" << std::endl;

		ofs_log << "ite:" << i << "   E=" << E << std::endl;
		ofs << i << " " << E << std::endl;

		{
			//W̘avZi`FbNj
			double sumBn = 0;
			for (int n = 0; n <= N; n++) {
				sumBn += abs(Bn[n]);
			}
			std::cout << "sumBn =" << sumBn << std::endl;
			ofs_log << "#sumBn = " << sumBn << std::endl;
		}


		if (maxE < E) {
			std::cout << "update Best Bn:" << std::endl;
			ofs_log << "update Best Bn:" << std::endl;
			for (int n = 0; n <= N; n++) {
				Bn_best[n] = Bn[n];
				maxE = E;
				std::cout << n << ":" << Bn_best[n] << "  ";
				ofs_log << n << " " << Bn_best[n] << std::endl;
			}
			std::cout << std::endl << std::endl;
			ofs_log << std::endl << std::endl;
		}
	}
	ofs.close();


	Vector3 *r, *v, *rb, *vb, *ab;
	r = new Vector3[NN / skip + 1];
	v = new Vector3[NN / skip + 1];
	rb = new Vector3[NN / skip + 1];
	vb = new Vector3[NN / skip + 1];
	ab = new Vector3[NN / skip + 1];
	locus(Bn_best, r, v, rb, vb, ab);

	//t@C̐ݒ
	std::ostringstream filename2;
	filename2 << "output/ForcedVibrationSinglePendulumMotion_RK_" << l << ".txt";
	// t@Co̓Xg[̏
	std::ofstream ofs2(filename2.str());

	ofs2 << "#x:" << std::endl;
	ofs2 << "#legend:UqzW ͊wIGlM[/10 x_xW+1" << std::endl;
	ofs2 << "#showLines: true true true true true true" << std::endl;
	ofs2 << "#showMarkers: false false false false false false" << std::endl;
	ofs2 << "#fills: false false false false false false" << std::endl;
	ofs2 << "#xrange:" << 0 << " " << t_max << " " << t_max / 10 << std::endl;
	ofs2 << "#yrange:" << 0 << " " << 2.4 << " " << 0.2 << std::endl;

	for (int i = 0; i <= NN / skip; i++) {
		double time = dt * skip * i;
		double energy = 1.0 / 2.0 * m * v[i].lengthSq() + m * g * r[i].z;

		ofs2 << time << " " << r[i].z << " " << energy / 10.0 << " " << rb[i].x + 1.0 << std::endl;
		//std::cout << "t =" << time << " ";
		//std::cout << "r=(" << r[i].x << "," << r[i].y << "," << r[i].z << ")" << " ";
		//std::cout << "v=(" << v[i].x << "," << v[i].y << "," << v[i].z << ")" << std::endl;
	}

	ofs2.close();


	//t@C̐ݒ
	std::ostringstream filename3;
	filename3 << "output/ForcedVibrationSinglePendulumMotion_coefficient_" << l << ".txt";
	// t@Co̓Xg[̏
	std::ofstream ofs3(filename3.str());


	ofs3 << "#x:n" << std::endl;
	ofs3 << "#y:Bn" << std::endl;
	ofs3 << "#showLines: false false false false false false" << std::endl;
	ofs3 << "#showMarkers: true true true true true true" << std::endl;
	ofs3 << "#fills: false false false false false false" << std::endl;
	ofs3 << "#xrange:" << 0 << " " << N << " " << N / 10 << std::endl;
	ofs3 << "#yrange:" << -1.0 << " " << 1.0 << " " << 0.2 << std::endl;

	for (int n = 0; n <= N; n++) {
		ofs3 << n << " " << Bn_best[n] << std::endl;
	}
	ofs3.close();


	std::cout << "finished" << std::endl;

	int a;
	std::cin >> a;
	return a;
}


/*
gccRpC
g++ -c Matrix.cpp -std=c++14 -O2
g++ -c FFNN.cpp -std=c++14 -O2 -fopenmp
g++ -c FFNNs.cpp -std=c++14 -O2 -fopenmp
g++ -c main.cpp -std=c++14 -O2 -fopenmp
g++ main.o Matrix.o FFNN.o FFNNs.o -fopenmp


g++ -c Matrix.cpp -std=c++14 -O2
g++ -c FFNN.cpp -std=c++14 -O2
g++ -c FFNNs.cpp -std=c++14 -O2
g++ -c main.cpp -std=c++14 -O2
g++ main.o Matrix.o FFNN.o FFNNs.o
*/